package ubisec.configuration;

import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXParseException;
import org.xml.sax.SAXException;
import org.xml.sax.Attributes;
import java.util.Vector;

/**
 * 
 * @author Rafik CHIBOUT
 * @author Franois SAILHAN
 * 
 * @version 0.1 oct. 2004
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SAXHandler extends DefaultHandler{
  
  private int stat = 0;
  private int tableStart[][] = new int[23][19];
  private int tableEnd[][] = new int[23][19];
  private Vector elements = new Vector(19);
  private Setting set=null;
  private String lastLocalName="";
  
  public SAXHandler()
  {
  	set = new Setting();
  	initialization();
  }
  
  public SAXHandler(Setting set)
  {
    this.set = set;
    initialization();
  }
  
 private void initialization()
 {
  elements.addElement("servicediscovery");
  elements.addElement("directorydeployment");
  elements.addElement("hopsnumber");
  elements.addElement("portnumber");
  elements.addElement("bloomfilter");
  elements.addElement("activation");
  elements.addElement("size");
  elements.addElement("hashfunctionnumber");
  elements.addElement("cache");
  elements.addElement("profileport");
  elements.addElement("qos");
  elements.addElement("timingvalues");
  elements.addElement("sd");
  elements.addElement("election");
  elements.addElement("directory");
  elements.addElement("networkcover");
  elements.addElement("maxdirectoryrequested");
  elements.addElement("getservicerequesthops");
  elements.addElement("minperformance");

  tableStart[0][0]   = 1;
  tableStart[1][1]   = 2;
  tableStart[1][2]   = 3;
  tableStart[1][3]   = 4;
  tableStart[1][4]   = 6;
  tableStart[1][8]   = 10;
  tableStart[1][9]   = 5;
  tableStart[1][10]  = 13;
  tableStart[1][11]  = 15;
  tableStart[1][16]  = 20;
  tableStart[1][17]  = 21;
  tableStart[1][18]  = 22;
  tableStart[6][5]   = 7;
  tableStart[6][6]   = 8;
  tableStart[6][7]   = 9;
  tableStart[10][5]  = 11;
  tableStart[10][6]  = 12;
  tableStart[13][5]  = 14;
  tableStart[15][12] = 16;
  tableStart[15][13] = 17;
  tableStart[15][14] = 18;
  tableStart[15][15] = 19;
    
  tableEnd[1][0]     = 100;
  tableEnd[2][1]     = 1;
  tableEnd[3][2]     = 1;
  tableEnd[4][3]     = 1;
  tableEnd[5][9]     = 1;
  tableEnd[6][4]     = 1;
  tableEnd[7][5]     = 6;
  tableEnd[8][6]     = 6;
  tableEnd[9][7]     = 6;
  tableEnd[10][8]    = 1;
  tableEnd[11][5]    = 10;
  tableEnd[12][6]    = 10;
  tableEnd[13][10]   = 1;
  tableEnd[14][5]    = 13;
  tableEnd[15][11]   = 1;
  tableEnd[16][12]   = 15;
  tableEnd[17][13]   = 15;
  tableEnd[18][14]   = 15;
  tableEnd[19][15]   = 15;
  tableEnd[20][16]   = 1;
  tableEnd[21][17]   = 1;
  tableEnd[22][18]   = 1;
  
  stat = 0;
}


  public void startDocument() throws SAXException
  {
      stat = 0;
  }

  public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
  {
    if (elements.indexOf(localName.toLowerCase()) !=-1) stat = tableStart[stat][elements.indexOf(localName.toLowerCase())];
    else lastLocalName=localName.toLowerCase();
  }

  public void endElement(String uri, String localName, String qName) throws SAXException
  {
     if (elements.indexOf(localName.toLowerCase())!=-1) stat = tableEnd[stat][elements.indexOf(localName.toLowerCase())];
     else lastLocalName="";
  }

  public void characters(char[] ch, int start, int length)
  {
  	String chaine = new String(ch,start, length);
  	chaine.trim();
   	switch (stat)
	{
  	case 2:
  		if ((chaine!=null) && (chaine.equals("auto") || chaine.equals("true") || chaine.equals("false"))) set.DirectoryDeployment=chaine; break;
  	case 3:
  		try
		{
  			Integer tmp = new Integer(chaine);
  			set.HopsNumber=tmp.intValue();break;	
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}
  	case 4:
  		try
		{
  			Integer tmp = new Integer(chaine);
  		    set.PortNumber=tmp.intValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}
  	case 5:
  		try
		{
  			Integer tmp = new Integer(chaine);
  		    set.ProfilePort=tmp.intValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  		
  	case 7:set.BloomFilterActivation=(Boolean.valueOf(chaine)).booleanValue();break;
  	case 8:
  		try
		{
  			Integer tmp = new Integer(chaine);
  		    set.BloomFilterSize=tmp.intValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  	case 9:
  		try
		{
  			Integer tmp = new Integer(chaine);
  		    set.BloomFilterHashFunctionNumber=tmp.intValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  	case 11:
  		try
		{
  			Boolean bool = Boolean.valueOf(chaine);
  		    set.CacheActivation=bool.booleanValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("Error in Boolean definition");
		}   
  	case 12:
  		try
		{
  			Integer tmp = new Integer(chaine);
  		    set.CacheSize=tmp.intValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  	case 14:set.QoSActivation=(Boolean.valueOf(chaine)).booleanValue();break;
  	case 16:
  		try
		{
  			if (lastLocalName!=null && !lastLocalName.equals(""))
  			{
   				Integer tmp = new Integer(chaine);
  				if (lastLocalName.equalsIgnoreCase("LISTENING_PERIOD_VALUE")) {set.SD_LISTENING_PERIOD_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("ADVERTISEMENT_PERIOD_VALUE")) {set.SD_ADVERTISEMENT_PERIOD_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("ELECTION_WAITING_RESPONSE_TIME_VALUE")) {set.SD_ELECTION_WAITING_RESPONSE_TIME_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("WAITING_GET_SERVICE_RESPONSE_MIN_VALUE")) {set.SD_WAITING_GET_SERVICE_RESPONSE_MIN_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("WAITING_GET_SERVICE_RESPONSE_MAX_VALUE")) {set.SD_WAITING_GET_SERVICE_RESPONSE_MAX_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("CHECKING_PERFORMANCE_PERIOD")) {set.SD_CHECKING_PERFORMANCE_PERIOD=tmp.intValue();break;}
  			}
  			break;
  		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  	case 17:
  		try
		{
  			if (lastLocalName!=null && !lastLocalName.equals(""))
  			{
  				Integer tmp = new Integer(chaine);
  				if (lastLocalName.equalsIgnoreCase("ELECTION_HOPS_VALUE")) {set.ELECTION_HOPS_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("LISTENING_PERIOD_VALUE")) {set.ELECTION_LISTENING_PERIOD_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("ADVERTISEMENT_PERIOD_VALUE")) {set.ELECTION_ADVERTISEMENT_PERIOD_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("ELECTION_WAITING_RESPONSE_TIME_VALUE")) {set.ELECTION_WAITING_RESPONSE_TIME_VALUE=tmp.intValue();break;}
  			}
  			break;
  		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  	case 18:
  		try
		{
  			if (lastLocalName!=null && !lastLocalName.equals(""))
  			{
  				Integer tmp = new Integer(chaine);
  				if (lastLocalName.equalsIgnoreCase("LISTENING_PERIOD_VALUE")) {set.DIR_LISTENING_PERIOD_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("ADVERTISEMENT_PERIOD_VALUE")) {set.DIR_ADVERTISEMENT_PERIOD_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("ADVERTISEMENT_HOPS_VALUE")) {set.DIR_ADVERTISEMENT_HOPS_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("RESUME_EXCHANGE_PERIOD_VALUE")) {set.DIR_RESUME_EXCHANGE_PERIOD_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("WAITING_GET_SERVICE_RESPONSE_MIN_VALUE")) {set.DIR_WAITING_GET_SERVICE_RESPONSE_MIN_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("WAITING_GET_SERVICE_RESPONSE_MAX_VALUE")) {set.DIR_WAITING_GET_SERVICE_RESPONSE_MAX_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("INITIAL_TTL_VALUE")) {set.DIR_INITIAL_TTL_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("TTL_UPDATING_VALUE")) {set.DIR_TTL_UPDATING_VALUE=tmp.intValue();break;}
  			}
  			break;
  		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  	case 19:
  		try
		{
  			if (lastLocalName!=null && !lastLocalName.equals(""))
  			{
  				if (lastLocalName.equalsIgnoreCase("BROADCAST_ADDRESS_VALUE"))  {set.BroadcastAddress=chaine;break;}
  				Integer tmp = new Integer(chaine);
  				if (lastLocalName.equalsIgnoreCase("NEIGHBORS_ADVERTISEMENT_VALUE"))  {set.COVER_NEIGHBORS_ADVERTISEMENT_VALUE=tmp.intValue();break;}
  				if (lastLocalName.equalsIgnoreCase("NEIGHBORS_LISTS_TTL_UPDATE_VALUE"))  {set.COVER_NEIGHBORS_LISTS_TTL_UPDATE_VALUE=tmp.intValue();break;}
  			}
  			break;
  		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}   
  	case 20:
  		try
		{
  			Integer tmp = new Integer(chaine);
  		    set.MaxDirectoryRequested=tmp.intValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}
  	case 21:
  		try
		{
  			Integer tmp = new Integer(chaine);
  		    set.GetServiceRequestHops=tmp.intValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}
  	case 22:
  		try
		{
  			Float tmp = new Float(chaine);
  		    set.MinPerformance=tmp.floatValue();break;
		}
  		catch(Exception ex)
		{
  			System.out.println("malFormed number "+chaine);
		}
  	}

  }
  
  public void endDocument() throws SAXException
  {
  }
  
  public void error(SAXParseException sAXParseException) throws SAXException
  {
    //System.out.println("Vous avez une erreur dans votre message SOAP");
  }
    public void fatalError(SAXParseException sAXParseException) throws SAXException
    {
    //System.out.println("Vous avez une erreur dans votre message SOAP");
    }
    
 public void startPrefixMapping(String prefix, String uri)
 {
 }
 public Setting getSetting()
 {
 	return set;
 }

}
