package ubisec.discovery;

import ubisec.profile.*;
import ubisec.util.BitSet2;
import ubisec.util.bloomfilter.*;
import ubisec.configuration.Setting;

/**
*
* DirectoryResume.java
*
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 oct. 2004
*
*  
*/
public class DirectoryResume
{
    NodeProfile Profile=null;
    BloomFilter resume=null;
    int status = 0;
    int TTL=12000;

    /*   public DirectoryResume(NodeProfile Profile, BitSet bitSet)
    {
	this.Profile=Profile;
	this.resume= new BloomFilter(bitSet,10); 
    }
    */

    public DirectoryResume(NodeProfile Profile)
    {
	this.Profile=Profile;
	//resume = new BloomFilter(28 * 1000, 10);
	resume = new BloomFilter(Setting.BloomFilterSize, Setting.BloomFilterHashFunctionNumber);

    }

    public DirectoryResume(NodeProfile Profile, byte[] bytes)
    {
	this.Profile=Profile;
	//this.resume= new BloomFilter(bytes.length*8,10);
	this.resume= new BloomFilter(bytes.length*8,Setting.BloomFilterHashFunctionNumber);
	this.resume.setBloomFilter(bytes); 
	if (bytes != null) status = 1;
    }

   public DirectoryResume(NodeProfile Profile, BloomFilter resume)
    {
	this.Profile=Profile;
	this.resume= resume;
	if (resume != null) status = 1;
    }

    public void setDirectoryProfile(NodeProfile Profile)
    {
	this.Profile = Profile;
    }

    public void setDirectoryResume(BitSet2 bitSet)
    {
	this.resume= new BloomFilter(bitSet,10); 
	status = 1;
    }

    public void setDirectoryResume(byte[] bytes)
    {
	//if (resume==null) resume= new BloomFilter(bytes.length*8,10); 
	if (resume==null) resume= new BloomFilter(bytes.length*8,4); 
	resume.setBloomFilter(bytes);
	status = 1;
    }

    public void setDirectoryResume(BloomFilter resume)
    {
	this.resume = resume;
	if (resume != null) status = 1;
    }

    public void setTTL(int TTL)
    {
    	this.TTL=TTL;
    }
    public NodeProfile getDirectoryProfile()
    {
	return Profile;
    }

    public BloomFilter getDerictoryBloomFilter()
    {
	return resume;
    }

    public int getTTL()
    {
    	return TTL;
    }
    public BitSet2 getDirectoryBitSet()
    {
	return resume.getBloomFilter();
    }

    public byte[] getDirectoryResumeBytes()
    {
	return resume.getBloomFilterBytes();
    }

    public int status()
    {
    	return status;
    }
	
    public boolean hasIPAddress(String IP)
    {
	if (Profile.getIPAddress().equals(IP)) return true;
	return false;
    }
}
