package ubisec.discovery;

import javax.xml.namespace.QName;
import javax.wsdl.Definition;

/**
*
* WSRegistryEntry.java
*
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 oct. 2004
*
*  
*/
public class WSRegistryEntry 
{
    QName serviceName =null;
    String endPoint    ="";
    String wsdlCustLocal = null;
    String wsdlCustRemote = null;
    Definition wsdlDef = null;
    String wsdlDocument = ""; // add to give better perfs, don't need to make the String from Definition for send it
    //int TTL             =-1; // Time To Live
    
    
    // QoS parameter
    QoSParameters QoS = new QoSParameters();
   
    long[] accessTimes = new long[100];
    int timesCurrentPosition = 0;
    double popularity = 0;

    public WSRegistryEntry()
    {
	
    }
    
    /*
    public WSRegistryEntry(QName serviceName, Definition wsdlDef, String wsdlDocument, String endPoint, int TTL)
    {
    	this.serviceName  = serviceName;
		this.endPoint     = endPoint;
		this.wsdlDef      = wsdlDef;
		this.wsdlDocument = wsdlDocument;
		//this.TTL          = TTL; 
		accessTimes[99] = 0;
    }*/
    
    public WSRegistryEntry(QName serviceName, Definition wsdlDef, String wsdlDocument, String endPoint)
    {
    	this.serviceName  = serviceName;
    	this.endPoint     = endPoint;
    	this.wsdlDef      = wsdlDef;
    	this.wsdlDocument = wsdlDocument;
    	accessTimes[99] = 0;
    }
    
    public WSRegistryEntry(Definition wsdlDef, String wsdlDocument, String endPoint)
    {
    	this.endPoint    = endPoint;
    	this.wsdlDef     = wsdlDef;
    	this.wsdlDocument = wsdlDocument;
    	accessTimes[99] = 0;
    }
    
    public void setServiceName(QName serviceName)
    {
    	this.serviceName = serviceName;
    }

    public void setEndPoint(String endPoint)
    {
    	this.endPoint = endPoint;
    }

    public void setWSDLDefinition(Definition wsdlDef)
    {
    	this.wsdlDef = wsdlDef;
    }

    public void setWSDLDocument(String wsdlDocument)
    {
    	this.wsdlDocument = wsdlDocument;
    }

    public void setTTL(long TTL)
    {
    	QoS.setServiceTTL(TTL); 
    }

    public QName getServiceName()
    {
    	return serviceName;
    }

    public String getEndPoint()
    {
    	return endPoint;
    }

    public Definition getWSDLDefinition()
    {
    	return wsdlDef;
    }

    public void setWSDLCustLocal(String wsdl)
    {
    	wsdlCustLocal= wsdl;
    }
    
    
    public void setWSDLCustRemote(String wsdl)
    {
    	wsdlCustRemote = wsdl;
    }
    
    public String getWSDLCustLocal()
    {
    	return wsdlCustLocal;
    }
    
    
    public String getWSDLCustRemote()
    {
    	return wsdlCustRemote;
    }
    
   public String getWSDLDocument()
    {
   		return wsdlDocument;
    }

    public long getTTL()
    {
    	return QoS.getServiceTTL(); 
    }
    
    public void addAccessTimes(long time)
    {
    	accessTimes[timesCurrentPosition] = time;
    	timesCurrentPosition++;
    	if (timesCurrentPosition==accessTimes.length) timesCurrentPosition =0;
    }
    
    public long getLastAccessTime()
    {
    	if (timesCurrentPosition > 0) return accessTimes[timesCurrentPosition-1];	
    	return accessTimes[99]; // return the last one	
    }
    
    public double getPopularity()
    {
    	return popularity;
    }
    
    public void incrementPopularity()
    {
    	if (popularity<0) popularity = 1;
    	else popularity++;
    	System.out.println("*******popularity of service "+serviceName.getLocalPart()+" = "+popularity);
    }
    
    public void decrementPopularity(double frequenceServiceAccess)
    {
    	popularity-=frequenceServiceAccess;
    	System.out.println("*******frequenceServiceAccess="+frequenceServiceAccess);
    	System.out.println("*******popularity of service "+serviceName.getLocalPart()+" = "+popularity);
    }
    
    // QoS Functions
    
    public void setQoSParameters(QoSParameters QoS)
    {
    	this.QoS = new QoSParameters(QoS);
    }
    
    public QoSParameters getQoSParameters()
    {
    	return QoS;
    }
    
    public void updateTTL(long time)
	{
    	if (QoS.getServiceTTL()>0) 
    	{
    		long timeLeft = QoS.getServiceTTL() - time;
    		if (timeLeft>0) QoS.setServiceTTL(timeLeft);
    		else QoS.setServiceTTL(0);
    	}
	}
    
    
    public void updateQoSTTL(long time)
	{
    	QoS.updateTTL(time);
	}
    
    
}
