

package ubisec.discovery.message;

import ubisec.util.BitSet2;
import ubisec.net.IPAddress;

/**
*
* 
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 oct. 2004
*
* @see ubisec.discovery.message.MessageFactory
* @see ubisec.discovery.message.MessageImpl
*  
*/

public interface Message
{
 
    public void setMessageNumber(int messageNumber);
    public void setMessageType(BitSet2 messageType);
    public void setMessageSource(IPAddress messageSource);
    public void setMessageDestination(IPAddress messageDestination);
    public void setMessageInitiator(IPAddress messageInitiator);
    public void setMessagePort(int port);
    public void setMessageHop(BitSet2 messageHop);
    public void setMessageHopCounter(BitSet2 hopCounter);
    public void setMessageContent(byte[] messageContent);
    public void setMessageLength(int length);
    public void setTTL(int ttl);
    public void setMPRList(IPAddress[] mpr);
    public int getMessageNumber();
    public BitSet2 getMessageType() ;
    public IPAddress getMessageSource();
    public IPAddress getMessageDestination();
    public IPAddress getMessageInitiator();
    public int getMessagePort();
    public BitSet2 getMessageHop();
    public BitSet2 getMessageHopCounter();
    public byte[] getMessageContent();
    public int getMessageLength();
    public byte[] getBytes();  
    public int getTTL();
    public IPAddress[] getMPRList();
    public Object clone();
}
