package ubisec.discovery.message;

import ubisec.util.*;
import ubisec.net.IPAddress;

/**
*
* 
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 sept. 2004
*
* @see ubisec.discovery.message.Message
* @see ubisec.discovery.message.MessageFactory
*  
*/

public class MessageImpl implements Message
{
    int messageNumber=0;
    BitSet2 messageType = new BitSet2();
    IPAddress messageSource = new IPAddress();
    IPAddress messageDestination = new IPAddress();
    IPAddress messageInitiator = new IPAddress();
    int port=0;
    BitSet2 messageHop = new BitSet2();
    BitSet2 hopCounter = new BitSet2();
    int messageLength=0;
    byte[] messageContent = new byte[0];
    int ttl;
    IPAddress[] MPR= new IPAddress[0];

    public void setMessageNumber(int messageNumber)
    {
	this.messageNumber=messageNumber;
    }
    
    public void setMessageType(BitSet2 messageType) 
    {
    this.messageType=messageType;
    }
    
    public void setMessageSource(IPAddress messageSource)
    {
	this.messageSource=messageSource;
    }

    public void setMessageDestination(IPAddress messageDestination)
    {
	this.messageDestination=messageDestination;
    }
    
    public void setMessageInitiator(IPAddress messageInitiator)
    {
	this.messageInitiator=messageInitiator;
    }
    
    public void setMessagePort(int port)
    {
	this.port = port;
    }

    public void setMessageHop(BitSet2 messageHop)
    {
	this.messageHop= messageHop;
    }

    public void setMessageHopCounter(BitSet2 hopCounter)
    {
	this.hopCounter = hopCounter;
    }    

    public void setMessageContent(byte[] messageContent)
    {
	this.messageContent=messageContent;
	messageLength=this.messageContent.length;
    }
    public void setTTL(int ttl)
    {
    	this.ttl=ttl;
    }
    
    public void setMPRList(IPAddress[] MPR)
    {
    	this.MPR = MPR; 
    }
    
    public void setMessageLength(int length)
    {
	messageLength = length;
    }

    public int getMessageNumber()
    {
	return messageNumber;
    }
    
    public BitSet2 getMessageType() 
    {
	return messageType;
    }
    
    public IPAddress getMessageSource()
    {
	return messageSource;
    }

    public IPAddress getMessageDestination()
    {
	return messageDestination;
    }

    public IPAddress getMessageInitiator()
    {
	return messageInitiator;
    }
    
    public int getMessagePort()
    {
	return port;
    }    

    public BitSet2 getMessageHop()
    {
	return messageHop;
    }
    
    public BitSet2 getMessageHopCounter()
    {
	return hopCounter;
    }

    public byte[] getMessageContent()
    {
	return messageContent;
    }
    
    public int getTTL()
    {
    	return ttl;
    }
    
    public IPAddress[] getMPRList()
    {
    	return MPR;
    }
    
    public int getMessageLength()
    {
	return messageLength;
    }
    
    public byte[] getBytes()  //important to using in send message
    {
	byte[] tmp = new byte[27];
	//	tmp[0] = (new Integer(messageNumber)).byteValue();
	BigBitSet bigBitSet = new BigBitSet(messageNumber);
	tmp[0] = bigBitSet.getBitSet()[0].getByte();
	tmp[1] = bigBitSet.getBitSet()[1].getByte();
	tmp[2] = bigBitSet.getBitSet()[2].getByte();
	tmp[3] = bigBitSet.getBitSet()[3].getByte();

	tmp[4] = messageType.getByte();
	tmp[5] = messageSource.getIPAddress()[0].getByte();
	tmp[6] = messageSource.getIPAddress()[1].getByte();
	tmp[7] = messageSource.getIPAddress()[2].getByte();
	tmp[8] = messageSource.getIPAddress()[3].getByte();
	
	tmp[9] = messageDestination.getIPAddress()[0].getByte();
	tmp[10] = messageDestination.getIPAddress()[1].getByte();
	tmp[11] = messageDestination.getIPAddress()[2].getByte();
	tmp[12] = messageDestination.getIPAddress()[3].getByte();
	
	tmp[13] = messageInitiator.getIPAddress()[0].getByte();
	tmp[14] = messageInitiator.getIPAddress()[1].getByte();
	tmp[15] = messageInitiator.getIPAddress()[2].getByte();
	tmp[16] = messageInitiator.getIPAddress()[3].getByte();
	
	//tmp[10] = (new Integer(port)).byteValue();
	bigBitSet = new BigBitSet(port);
	tmp[17] = bigBitSet.getBitSet()[0].getByte();
	tmp[18] = bigBitSet.getBitSet()[1].getByte();
	tmp[19] = bigBitSet.getBitSet()[2].getByte();
	tmp[20] = bigBitSet.getBitSet()[3].getByte();

	tmp[21] = messageHop.getByte();
	tmp[22] = hopCounter.getByte();

	//tmp[13] = (new Short(messageLength)).byteValue();
	bigBitSet = new BigBitSet(messageLength);
	tmp[23] = bigBitSet.getBitSet()[0].getByte();
	tmp[24] = bigBitSet.getBitSet()[1].getByte();
	tmp[25] = bigBitSet.getBitSet()[2].getByte();
	tmp[26] = bigBitSet.getBitSet()[3].getByte();
	
    
	
	byte[] toReturn = new byte[messageContent.length+27+4+(MPR.length*4)];
	int i=0;
	for (i=0; i<tmp.length;i++)
	    toReturn[i]=tmp[i];
	
	bigBitSet = new BigBitSet(MPR.length);
    toReturn[i] = bigBitSet.getBitSet()[0].getByte();i++; 
    toReturn[i] = bigBitSet.getBitSet()[1].getByte();i++;
	toReturn[i] = bigBitSet.getBitSet()[2].getByte();i++;
	toReturn[i] = bigBitSet.getBitSet()[3].getByte();i++;
	
	int k =0;
	for (k=0; k<MPR.length; k++)
	{
		toReturn[i+4*k]   =  MPR[k].getIPAddress()[0].getByte();
		toReturn[i+4*k+1] =  MPR[k].getIPAddress()[1].getByte();
		toReturn[i+4*k+2] =  MPR[k].getIPAddress()[2].getByte();
		toReturn[i+4*k+3] =  MPR[k].getIPAddress()[3].getByte();
	}
	i= i +(MPR.length*4);
	for (int j=0; j<messageContent.length;j++)
	    toReturn[i+j]=messageContent[j];
	return toReturn;
    }
    

    public Object clone()
    {
	Message message = (Message)(new MessageImpl());
	message.setMessageNumber(getMessageNumber());
	message.setMessageType(getMessageType()); 
	message.setMessageSource(getMessageSource());
	message.setMessageDestination(getMessageDestination());
	message.setMessageInitiator(getMessageInitiator());
	message.setMessagePort(getMessagePort());
	message.setMessageHop(getMessageHop());
	message.setMessageHopCounter(getMessageHopCounter());
	message.setMessageContent(getMessageContent());
	message.setMessageLength(getMessageLength());
	return message;
    }



}
