package ubisec.discovery.message;

import java.util.*;
import ubisec.util.BitSet2;
import ubisec.discovery.message.util.MessageType;
import ubisec.net.*;
import ubisec.profile.NodeProfile;

/**
*
* 
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 sept. 2004
* 
*  
*/

public class MessagesManager
{
    private Vector messagesToSend = new Vector();
    private Vector messagesToBroadcast = new Vector();
    private Vector messagesReceived = new Vector();
    private Vector messagesToIgnore = new Vector();
    private int listenPort =0;
    public boolean start = false;
    private boolean dontRemove=true;
    private NetworkManager network = null;
    private int TTL4ReceivedMessages=30000;
    private int TTL4ReceivedUDPMessages=4000;
    private int TTL4MessagesTraces=4000;
    static private NetworkCover networkCover= null;
    
    //long t1 =0;
    public MessagesManager(){
    	networkCover= NodeProfile.networkCover;
    	}

    public MessagesManager(int port)
    {
    	networkCover= NodeProfile.networkCover;
    	start(port);
    }
/**
 * 
 * @param message
 * @param iPAddress
 * @param port
 * 
 */
   /*
    public void sendMessageTo(Message message , String iPAddress , int port)
    {
	//t1 = System.currentTimeMillis();
	//System.out.println("********Message type ="+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is puted at "+t1);
	message.setMessageDestination(new IPAddress(iPAddress));
	message.setMessagePort(port);
	messagesToSend.add(message);
	//System.out.println("Message type ="+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is sent at "+t1);
    }
    */
/**
 * 
 * @param message
 * @param iPAddress
 * @param port
 * 
 */
    public void sendInstantaneousMessageTo(Message message , String iPAddress , int port)
    {
	//long t1 = System.currentTimeMillis();
	IPAddress address = new IPAddress(iPAddress);
	NetworkManager.sendTo(message.getBytes(), address.getIPInetAddress(), port);
	//System.out.println("Instantaneous Message sent at "+t1);
    }

    public Message[] getMessagesType(BitSet2 messageType)
    {
    	int i =0;
    	Vector forReturn = new Vector(); 
    	while (i<messagesReceived.size())
    	    {
    		Message message =(Message)messagesReceived.elementAt(i);
    		if (message.getMessageType().equals(messageType)) 
    		    {
    			forReturn.add((Message)message.clone());
    			// remove message
    			messagesReceived.removeElementAt(i);
    		    }
    		else i++;
    	    }

    	Message[] messages = new Message[forReturn.size()];
    	for (i=0;i<messages.length;i++)
    	    messages[i] = (Message)forReturn.elementAt(i);
    	return messages;
    	
    /*	
	int i =0;
	Vector forReturn = new Vector();
	try
	{
	Iterator messagesIterator = messagesReceived.iterator(); 
	while (messagesIterator.hasNext())
	    {
		Message message =(Message)messagesIterator.next();
		if (message.getMessageType().equals(messageType)) 
		    {
			forReturn.add((Message)message.clone());
			// remove message
			messagesIterator.remove();
		    }
		else i++;
	    }
	}
	catch (Exception ex)
	{
	 
	}
	Message[] messages = new Message[forReturn.size()];
	for (i=0;i<messages.length;i++)
	    messages[i] = (Message)forReturn.elementAt(i);
	return messages;
	*/
    }
/**
 * 
 * @param messageType
 * @param messageNumber
 * @return
 * 
 */
    public Message[] getMessagesType(BitSet2 messageType , int messageNumber)
    {
    	int i =0;
    	Vector forReturn = new Vector(); 
    	while (i<messagesReceived.size())
    	    {
    		Message message =(Message)messagesReceived.elementAt(i);
    		if (message.getMessageType().equals(messageType) && message.getMessageNumber()==messageNumber) 
    		    {
    			//long t1 = System.currentTimeMillis();
    			//System.out.println("*********Message type ="+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is got at "+t1);
    			//System.out.println("message.getMessageNumber()==messageNumber "+message.getMessageNumber()+"=="+messageNumber);
    			forReturn.add((Message)message.clone());
    			// remove message
    			messagesReceived.removeElementAt(i);
    		    }
    		else i++;
    	    }

    	Message[] messages = new Message[forReturn.size()];
    	for (i=0;i<messages.length;i++)
    	    messages[i] = (Message)forReturn.elementAt(i);
    	return messages;
    	
    	/*
    	
	int i =0;
	Vector forReturn = new Vector(); 
	Iterator messagesIterator = messagesReceived.iterator();
	while (messagesIterator.hasNext())
	    {
		Message message =(Message)messagesIterator.next();
		if (message.getMessageType().equals(messageType) && message.getMessageNumber()==messageNumber) 
		    {
			//long t1 = System.currentTimeMillis();
			//System.out.println("*********Message type ="+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is got at "+t1);
			//System.out.println("message.getMessageNumber()==messageNumber "+message.getMessageNumber()+"=="+messageNumber);
			forReturn.add((Message)message.clone());
			// remove message
			messagesIterator.remove();
		    }
		else i++;
	    }

	Message[] messages = new Message[forReturn.size()];
	for (i=0;i<messages.length;i++)
	    messages[i] = (Message)forReturn.elementAt(i);
	return messages;
	*/
    }
    
    
    
    
    public Message[] getMessagesType(BitSet2 messageType , int messageNumber, IPAddress initiator)
    {
    	int i =0;
    	Vector forReturn = new Vector(); 
    	while (i<messagesReceived.size())
    	    {
    		Message message =(Message)messagesReceived.elementAt(i);
    		if (message.getMessageType().equals(messageType) && message.getMessageNumber()==messageNumber && message.getMessageInitiator().getHostIPAddress().equals(initiator.getHostIPAddress())) 
    		    {
    			//long t1 = System.currentTimeMillis();
    			//System.out.println("*********Message type ="+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is got at "+t1);
    			//System.out.println("message.getMessageNumber()==messageNumber "+message.getMessageNumber()+"=="+messageNumber);
    			forReturn.add((Message)message.clone());
    			// remove message
    			messagesReceived.removeElementAt(i);
    		    }
    		else i++;
    	    }

    	Message[] messages = new Message[forReturn.size()];
    	for (i=0;i<messages.length;i++)
    	    messages[i] = (Message)forReturn.elementAt(i);
    	return messages;
    }
    
/**
 * 
 * @return
 * 
 */
    public Message[] getAllMessages()
    {
	Message[] messages = new Message[messagesReceived.size()];
	for (int i=0;i<messages.length;i++)
	    messages[i] = (Message)((Message)messagesReceived.elementAt(i)).clone();
	messagesReceived.removeAllElements();
	return messages;
    }

   
    public void instantaneousBroadcastMessage(Message message , int port)
    {
    	String[] MPRList = networkCover.getMPR();
    	IPAddress[] MPRAddress = new IPAddress[MPRList.length];
    	for (int i=0; i< MPRList.length; i++)
    	{
    		MPRAddress[i]=new IPAddress(MPRList[i]);
    	
    	}
    	message.setMPRList(MPRAddress);
    	if (port !=-1) NetworkManager.broadcast(message.getBytes(), port);
    	else NetworkManager.broadcast(message.getBytes(), message.getMessagePort());
    }
/**
 * 
 * @param port
 * 
 */
    public void start(int port)
    {
	stop();
	listenPort = port;
	network = new NetworkManager();
	network.listenToPort(listenPort);
	messagesToSend.removeAllElements();
	messagesToBroadcast.removeAllElements();
	messagesReceived.removeAllElements();
	// start all threads
	Thread listeningUDP = listenUDPProcess();
	Thread listening = listenProcess();
	Thread sending = sendProcess();
	Thread broadcasting = broadcastProcess();
	//The application which uses MessagesManager must to clean the received messages when it needs to do it.
	//MassagesManager clean only trace of received messages to detecte the duplication message and ignore them.
	Thread update = updateTTLProcess();
	start = true;
	listeningUDP.start();
	listening.start();
	sending.start();
	broadcasting.start();
	update.start();
    }

    public void stop()
    {
    	start = false;
    }

    public void clean()
    {
    	//messagesToSend.removeAllElements();
        //messagesToBroadcast.removeAllElements();
        messagesReceived.removeAllElements();
        //private Vector messagesToIgnore = new Vector();
    }
    
    public void clean (BitSet2[] messageType)
    {
    	Iterator messagesIterator = messagesReceived.iterator();
    	while (messagesIterator.hasNext())
    	    {
    		Message message = (Message)messagesIterator.next();
    		int i=0;
    		while (i<messageType.length)
    		{
    			if (messageType[i].equals(message.getMessageType()))
    			{
    		      			messagesIterator.remove();
    		      			i=messageType.length;
    			}
    			i++;
    		}
    		    
    	    }
    }
    
    public void dontRemove(boolean dontRemove)
    {
    	this.dontRemove = dontRemove; 
    }
    
    private void addMessage(Message message)
    {
	if (!isAlreadyReceived(message)) 
	    {
		received(message);
		message.setTTL(TTL4ReceivedMessages);
		messagesReceived.add(message);
		//System.out.println("MessagesManager: Accepted Message IP="+message.getMessageSource().getHostIPAddress()+" Type="+message.getMessageType().getInt()+" Number="+message.getMessageNumber()+ "HOPS="+message.getMessageHop().getInt());
	    }
	else System.out.println("MessagesManager: Ignored Message IP="+message.getMessageSource().getHostIPAddress()+" Type="+message.getMessageType().getInt()+" Number="+message.getMessageNumber()+ "HOPS="+message.getMessageHop().getInt());
    }
    
    private void addUDPMessage(Message message)
    {
	if (!isAlreadyReceived(message)) 
	    {
		received(message);
		message.setTTL(TTL4ReceivedUDPMessages);
		messagesReceived.add(message);
		//System.out.println("MessagesManager: Accepted Message IP="+message.getMessageSource().getHostIPAddress()+" Type="+message.getMessageType().getInt()+" Number="+message.getMessageNumber()+ "HOPS="+message.getMessageHop().getInt());
	    }
	else System.out.println("MessagesManager: Ignored Message IP="+message.getMessageSource().getHostIPAddress()+" Type="+message.getMessageType().getInt()+" Number="+message.getMessageNumber()+ "HOPS="+message.getMessageHop().getInt());
    }

    private boolean isRequest(BitSet2 type)
    {
    	if (type.getInt()==MessageType.DIRECTORY_ELECTION_PROCESS_REQUEST.getInt()) return true;
    	return false;
    }
    
    private boolean isAlreadyReceived(Message message)
    {
    	if (message == null) return true;
    	MessageInfo info = new MessageInfo();
    	info.setIPSource(message.getMessageSource().getHostIPAddress());
    	info.setType(message.getMessageType().getInt());;
    	info.setNumber(message.getMessageNumber());
    	if (info.getIPSource().equals(NetworkManager.getLocalIPAddresses()[0])) return true;
    	if (message.getMessageInitiator().getHostIPAddress().equals(NetworkManager.getLocalIPAddresses()[0]) && isRequest(message.getMessageType()))
    		return true;
    	int i= 0;
    	while (i<messagesToIgnore.size())
    	{
    		try
			{
    			MessageInfo ExistingMessageInfo =(MessageInfo)messagesToIgnore.elementAt(i);
    			if (info.equals(ExistingMessageInfo)) return true;
			}
    		catch(Exception ex)
			{
    			System.out.println("Messages Manager: read write at the same time in messagesToIgnor");
			}
    		i++;
    	}
    	
    /*
	int i=0;
	while (i<256 && (number<messagesNumber[type][i] || number>messagesNumber[type][i+1]) && messagesNumber[type][i] != -1) i+=2;
	if (i>=256 || messagesNumber[type][i]==-1) return false;
	return true;
      */
	return false;
    }

    private void received(Message message)
    { 
    	MessageInfo info = new MessageInfo();
    	info.setIPSource(message.getMessageSource().getHostIPAddress());
    	info.setType(message.getMessageType().getInt());;
    	info.setNumber(message.getMessageNumber());
    	info.setTTL(TTL4MessagesTraces);
    	messagesToIgnore.add(info);
	/*	int i=0;
	while (i<256 && (number!=messagesNumber[type][i]-1) && (number!=messagesNumber[type][i+1]+1) && messagesNumber[type][i]!=-1)
	*/
    }

    public Thread sendProcess() {
        try
	    {
		Thread sendProcessThread = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {
				while (start)
				    {
					try
					    {
						while (messagesToSend.size()>0)
						    {
							Message message = (Message)messagesToSend.elementAt(0);
							//long t1 = System.currentTimeMillis();
							NetworkManager.sendTo(message.getBytes(), message.getMessageDestination().getIPInetAddress(), message.getMessagePort());
							if (message != null && message.getMessageType().equals(MessageType.DIRECTORY_ELECTION_PROCESS_RESPONSE)) System.out.println("Messages Manager:Election Response is sent to "+message.getMessageDestination());
							//System.out.println("*********Message type ="+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is sent at "+t1);
							messagesToSend.removeElementAt(0);
						    }
						Thread.sleep(50);
					    }
					catch (Exception ex)
					    {
						System.out.println("Error at MessageManager.sendProcess.run()");
						ex.printStackTrace();
					    }
				    }
			    }
			});
		return sendProcessThread;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error at create MessageManager.sendProcess Thread");
	    }
	return null;
    }
    
    public Thread broadcastProcess() {
        try
	    {
		Thread broadcastProcessThread = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {
				while (start)
				    {
					try
					    {
						while (messagesToBroadcast.size()>0)
						    {
							Message message = (Message)messagesToBroadcast.elementAt(0);
							NetworkManager.broadcast(message.getBytes(), message.getMessagePort());
							messagesToBroadcast.removeElementAt(0);
						    }
						Thread.sleep(50);
					    }
					catch (Exception ex)
					    {
						System.out.println("Error at MessageManager.broadcastProcess.run()");
						ex.printStackTrace();
					    }
				    }
			    }
			});
		return broadcastProcessThread;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error at create MessageManager.broadcastProcess Thread");
	    }
	return null;
    }
    
    public Thread listenUDPProcess() {
        try
	    {
		Thread listenUDPProcessThread = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {
			    	while (start)
				    {
					try
					    {
						//byte[] data = NetworkManager.getReceivedUDPData(listenPort);
						//long t1 = System.currentTimeMillis();
						byte[] data = network.getReceivedUDPData();
						
						if (data!=null)
						{
						//long t2 = System.currentTimeMillis();
						//System.out.println("****Message received in MessagesManager in time ="+(t2-t1));
						//t1 = System.currentTimeMillis();
						Message message = (Message)MessageFactory.createMessage(data);		
						//t2 = System.currentTimeMillis();
						//System.out.println("****Message build in time ="+(t2-t1));
						//t1 = System.currentTimeMillis();
						
						if (!isAlreadyReceived(message))
						{
							addUDPMessage(message);
						
						IPAddress[] MPRAddress = message.getMPRList();
						
						Vector MPRVect = new Vector();
						for (int z=0; z<MPRAddress.length; z++)
						{
							MPRVect.add(MPRAddress[z].getHostIPAddress());
							//System.out.println("MPRAddress["+z+"].getHostIPAddress()="+MPRAddress[z].getHostIPAddress());
						}
						
						if (MPRVect.contains(NetworkManager.getLocalIPAddresses()[0]) && message.getMessageHop().getInt()>(message.getMessageHopCounter().getInt()+1))
						{
							System.out.println("I will forward the message from "+message.getMessageSource().getHostIPAddress());
							System.out.println("MPRVect received is ="+MPRVect.toString());
							Message messageToForward = (Message)message.clone();
							//MPRVect.removeElement(NetworkManager.getLocalIPAddresses()[0]);
							String[] StrIPAddress = networkCover.getMPR();
							
							MPRAddress = new IPAddress[StrIPAddress.length];
							
							for (int z=0; z<StrIPAddress.length; z++)
								MPRAddress[z] = new IPAddress(StrIPAddress[z]);
													
							if (messageToForward.getMessageType().equals(MessageType.DIRECTORY_ELECTION_PROCESS_REQUEST))
								{
								System.out.println("I will forward an election request message from "+messageToForward.getMessageSource().getHostIPAddress());	
								messageToForward.setMessageSource(new IPAddress(NetworkManager.getLocalIPAddresses()[0]));
								}
							messageToForward.setMPRList(MPRAddress);
							BitSet2 counter = (BitSet2)messageToForward.getMessageHopCounter().clone();
							counter.increment();
							messageToForward.setMessageHopCounter(counter);
							instantaneousBroadcastMessage(messageToForward, messageToForward.getMessagePort());
						}
						}
						//t2 = System.currentTimeMillis();
						//System.out.println("****Message add to messagesReceived int time ="+(t2-t1));
						//long t2 = System.currentTimeMillis(); 
						//System.out.println("Message type "+message.getMessageType().getInt()+" is available after "+t2);
						}
					    }
					catch (Exception ex)
					    {
						System.out.println("Error at MessageManager.listenUDPProcess.run()");
					    }
				    }
			    }
			});
		return listenUDPProcessThread;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error at create MessageManager.listenUDPProcess Thread");
	    }
	return null;
    }

    public Thread listenProcess() {
        try
	    {
		Thread listenProcessThread = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {	
			    	while (start)
				    {
					try
					    {
						//byte[] data = NetworkManager.getReceivedData(listenPort);
						//long t1 = System.currentTimeMillis();
						byte[] data = network.getReceivedData();
						if (data!=null)
						{	
						//long t2 = System.currentTimeMillis();
						//System.out.println("****Message received in MessagesManager in time ="+(t2-t1));
						
						if (data == null) System.out.println("in MessageManager.ListenProcess the received data are nul");
						//long t1 = System.currentTimeMillis();
						Message message = (Message)MessageFactory.createMessage(data);		
						//System.out.println("*********Message type ="+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is received at "+t1);
						//t2 = System.currentTimeMillis();
						//System.out.println("****Message build in time ="+(t2-t1));
						//t1 = System.currentTimeMillis();		                   
						if (message != null && message.getMessageType().equals(MessageType.DIRECTORY_ELECTION_PROCESS_RESPONSE)) System.out.println("Messages Manager:Election Response is received from "+message.getMessageSource().getHostIPAddress());
						messagesReceived.add(message);
						//t2 = System.currentTimeMillis(); 
                                                //System.out.println("****Message add to messagesReceived int time ="+(t2-t1));
						
						//System.out.println("Message type "+message.getMessageType().getInt()+" number="+message.getMessageNumber()+" is available after "+t2);
					    }
					    }
					catch (Exception ex)
					    {
						System.out.println("Error at MessageManager.listenProcess.run()");
						ex.printStackTrace();
					    }
					
				    }
			    }
			});
		return listenProcessThread;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error at create MessageManager.listenProcess Thread");
	    }
	return null;
    }
    
    
    public Thread updateTTLProcess() {
        try
	    {
		Thread updateTTLProcessThread = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {				
				while (start)
				    {
					try
					    {
						Iterator messagesToIgnoreIterator = messagesToIgnore.iterator();
						while (messagesToIgnoreIterator.hasNext())
						{
							MessageInfo info = (MessageInfo)messagesToIgnoreIterator.next();
							info.setTTL(info.getTTL()-100);
							if (info.getTTL()<=0)
								{
								//System.out.println("Message Manager: trace message from "+info.getIPSource()+" number "+info.getNumber()+" type "+info.getType()+" is removed");
								messagesToIgnoreIterator.remove();
								}
						}
						/*
						Iterator messagesIterator = messagesReceived.iterator();
						while (messagesIterator.hasNext())
						{
							Message message = (Message)messagesIterator.next();
							message.setTTL(message.getTTL()-100);
							if (message.getTTL()==0 && !dontRemove) 
								{
								if (message != null && message.getMessageType().equals(MessageType.DIRECTORY_GET_ALL_RESUMES_RESPONSE)) System.out.println("Message Manager: message get all resume response from "+message.getMessageSource().getHostIPAddress()+" number "+message.getMessageNumber()+" is removed");
								if (message != null && message.getMessageType().equals(MessageType.DIRECTORY_GET_ALL_RESUMES)) System.out.println("Message Manager: message get all resume request from "+message.getMessageSource().getHostIPAddress()+" number "+message.getMessageNumber()+" is removed");
								messagesIterator.remove();
								}
						}
						*/
						Thread.sleep(100);
					    }
					catch (Exception ex)
					    {
							System.out.println("Error at MessageManager.updateTTLProcess.run()");
							ex.printStackTrace();
					    }
				    }
			    }
			});
		return updateTTLProcessThread;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error at create MessageManager.updateTTLProcess Thread");
	    }
	return null;
    }
    
}
