package ubisec.util;

/**
*
* BigBitSet.java
*
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 oct. 2004
*
*  
*/
public class BigBitSet
{
    BitSet2[] bitsset = null;

    /*
    public BigBitSet(int nbits)
    {
	if (nbits%8 != 0) System.out.println("nbits must be multiple of 8");
	else 
	    {
		int part = nbits/8;
		bitsset = new BitSet2[part]; 
	    }
    }
    */

    public BigBitSet(byte[] data)
    {
	if (data !=null) 
	    {
		bitsset = new BitSet2[data.length];
		for (int i=0;i<data.length;i++)
		    bitsset[i]=new BitSet2(data[i]);
	    }
    }

    public BigBitSet(BitSet2[] bitsset)
    {
	this.bitsset = bitsset;
    }

    public BigBitSet(int number)
    {
	setInt(number);
    }

    public BigBitSet(short number)
    {
	setShort(number);
    }

    public void setInt(int number)
    {
	if (number>Power.power(2,31)-1) number = Power.power(2,31)-1;
	if (number<1-Power.power(2,31)) number = 1-Power.power(2,31);
	bitsset = new BitSet2[4];
	bitsset[0]= new BitSet2();
	bitsset[1]= new BitSet2();
	bitsset[2]= new BitSet2();
	bitsset[3]= new BitSet2();
	if (number<0) bitsset[3].set(7);
	int bitsetNum = 3;
	int bitsetCase = 6;
	for (int indice=30;indice>=0; indice--)
	    {
		int result = number/Power.power(2,indice);
		if (result !=0) 
		    {
			bitsset[bitsetNum].set(bitsetCase);
			number = number % Power.power(2,indice);
		    }
		if (bitsetCase != 0) bitsetCase--;
		else {
		    bitsetCase=7;
		    bitsetNum--;
		    }
	    }
    }

    public void setShort(short number)
    {
	int numbertmp = number;
	if (number>Power.power(2,15)-1) numbertmp = Power.power(2,15)-1;  
	if (number<1-Power.power(2,15)) numbertmp = 1-Power.power(2,15);
	bitsset = new BitSet2[2];
	bitsset[0]= new BitSet2();
	bitsset[1]= new BitSet2();
	if (number<0) bitsset[1].set(7);
	int bitsetNum = 1;
	int bitsetCase = 6;
	for (int indice=14;indice>=0; indice--)
	    {
		int result = numbertmp/Power.power(2,indice);
		if (result !=0) 
		    {
			bitsset[bitsetNum].set(bitsetCase);
			numbertmp = numbertmp % Power.power(2,indice);
		    }
		if (bitsetCase != 0) bitsetCase--;
		else {
		    bitsetCase=7;
		    bitsetNum--;
		    }
	    }
    }
    
    public String bitsSequence()
    {
	String forReturn ="";
	for (int i=0; i<bitsset.length;i++)
	    forReturn= forReturn+bitsset[i].bitsSequence(8);
	return forReturn;
    }

    public BitSet2[] getBitSet()
    {
	return bitsset;
    }

    public int getInt()
    {
	if (bitsset==null || bitsset.length!=4) return -1;
	int forReturn =0;
	int coef = 1;
	int signe= 1;
	if (bitsset[3].get(7)) 
	    {
		signe=-1;
		bitsset[3].clear(7);
	    } 
	for (int j=0;j<bitsset.length; j++)
	    {
		for (int i=0;i<8;i++)
		    {
			if (bitsset[j].get(i)) forReturn=forReturn+coef;
			coef = coef*2;
		    }
	    }
	if (signe==-1) bitsset[3].set(7);
	return (forReturn*signe);
    }

    public short getShort()
    {
	if (bitsset ==null || bitsset.length!=2) return -1;
	int forReturn =0;
	int coef = 1;
	int signe= 1;
	if (bitsset[1].get(7)) 
	    {
		signe=-1;
		bitsset[1].clear(7);
	    } 
	for (int j=0;j<bitsset.length; j++)
	    {
		for (int i=0;i<8;i++)
		    {
			if (bitsset[j].get(i)) forReturn=forReturn+coef;
			coef = coef*2;
		    }
	    }
	if (signe == -1) bitsset[1].set(7);
	Integer tmp = new Integer(forReturn*signe);
	return tmp.shortValue();
    }

    
}
