package ubisec.util.bloomfilter;

import ubisec.util.BitSet2;

/**
*
* BloomFilter.java
*
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 oct. 2004
*
*  
*/
public class BloomFilter{
    protected BitSet2 bitSet;
    protected MultiHash multiHash;
    protected int numFunc;
    //private int[] counter;
	//static String fName = "american.uc";

	///////////////////////////////////////////////////////////////////
	//Takes a size for the bitVector and the number of hash functions to be used.
	//If the size of the bitvecotor is too small or if the number of
	//hash functions is too small then you will get too many false positives.
    ///////////////////////////////////////////////////////////////////
    public BloomFilter(int filterSize, int numFunc){ 
	bitSet = new BitSet2(filterSize); 	//creates size number of bits and set them all to false
	this.numFunc = numFunc;
	//counter = new int[filterSize];
	multiHash = new MultiHash(numFunc, 0x8FFFFFFF, filterSize);
	//for(int i = 0; i < bitSet.length(); i++){
	//	System.out.println(i + ":" + bitSet.get(i));
	//}
    }

    public BloomFilter(BitSet2 filter, int numFunc){ 
	bitSet = filter;
	this.numFunc = numFunc;
	//counter = new int[filterSize];
	multiHash = new MultiHash(numFunc, 0x8FFFFFFF, filter.size());
	//for(int i = 0; i < bitSet.length(); i++){
	//	System.out.println(i + ":" + bitSet.get(i));
	//}
    }
    
    	///////////////////////////////////
	//
	///////////////////////////////////
    
	////////////////////////////////////
	//add string to filter	
	////////////////////////////////////
	public void addToFilter(String str){ 
		int tmp;
		for(int i = 0; i < numFunc; i++){
			tmp = multiHash.hash(i, str);
			bitSet.set(tmp, true);
			//counter[tmp]++;
			//System.out.println("Set bit: " + tmp);
		}	
		//System.out.println("add: "+str);
	}

    ////////////////////////////////////
    //remove string from filter	
    ////////////////////////////////////




	//////////////////////////
	//returns true if string is probably in the filter
	/////////////////////////
	public boolean isInFilter(String str){ 
	    // I think there is an error
	    // the below for give only true if the last bitset(index) is true
	    // It must replaced by inFilter = inFilter && bitSet.get(index);
	    // and inFilter must initialized on true 
		boolean inFilter = false;
		int index = 0;
		for(int i = 0; i < numFunc; i++){
			index = multiHash.hash(i, str);
			inFilter = bitSet.get(index);
		}
		return inFilter; 
	}

    public BitSet2 getBloomFilter()
    {
	return bitSet;
    }
    public void setBloomFilter(BitSet2 filter)
    {
	bitSet = filter;
    }

    public void setBloomFilter(byte[] bytes)
    {
	if (bytes.length*8 != bitSet.size()) return;
	bitSet = new BitSet2(bytes);
    }

    public byte[] getBloomFilterBytes()
    {
	return bitSet.getBytes();
    }

}//end class BloomFilter
