package ubisec.util.bloomfilter;

import java.io.*;


/**
*
* BloomFilter2.java
* A bloom Filter which contains counter than allows to remove somes entries
*
* @author Rafik CHIBOUT 
* @author Francoise SAILHAN
* @version 0.1 oct. 2004
*
*  
*/
public class BloomFilter2 extends BloomFilter {
    private int[] counter;
	
    public BloomFilter2(int filterSize, int numFunc){ 
	super(filterSize, numFunc);
	counter = new int[filterSize];
    }
    
    public static void main(String args[]){
		if(args.length != 1){
			System.out.println("Usage: java -cp . BloomFilter <file>");
			System.exit(1);
		}

		//BloomFilter bf = new BloomFilter(28 * 1000000, 6);
		BloomFilter2 bf = new BloomFilter2(28 * 100000, 10);
		try{
		//load bloom filter
		FileInputStream fis = new FileInputStream(new File(args[0]));
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		String line;
		while((line = br.readLine()) != null){
			bf.addToFilter(line);
		}
		br.close();
		br = null;

		//test filter
		/*
		fis = new FileInputStream(new File(args[0]));
		br = new BufferedReader(new InputStreamReader(fis));
		line = null;
		int found = 0;
		int missed = 0;
		while((line = br.readLine()) != null){
			if(bf.isInFilter(line)){
				found++;
			}
			else{
				missed++;
			}
		}
		br.close();
		br = null;
		System.out.println("Correctly found: " + found + " entries. Missed " + missed + " entries");
		*/
		//test

		System.out.println("Aaronic in the bloom? " +bf.isInFilter("Aaronic"));
		bf.removeFromFilter("Aaronic");
		System.out.println("Aaronic is removed");
		System.out.println("Aaronic in the bloom? " +bf.isInFilter("Aaronic"));
		br = new BufferedReader(new InputStreamReader(System.in));
		boolean inFilter;
		System.out.println("Enter words to search for in filter. Enter quitApp to quit");
		System.out.println("Enter word:");
		while( ((line = br.readLine()) != null) && line.compareTo("quitApp") != 0){
			System.out.println(bf.isInFilter(line));
			System.out.println("Enter word:");
		}

		br.close();
		br = null;

		}catch(Exception e){
		 	e.printStackTrace(); 
		}
	}//end main

	////////////////////////////////////
	//add string to filter	
	////////////////////////////////////
	public void addToFilter(String str){ 
		int tmp;
		for(int i = 0; i < numFunc; i++){
			tmp = multiHash.hash(i, str);
			bitSet.set(tmp, true);
			counter[tmp]++;
			//System.out.println("Set bit: " + tmp);
		}	
		//System.out.println("add2 :"+str);
	}

	////////////////////////////////////
	//remove string from filter	
	////////////////////////////////////
	public void removeFromFilter(String str){ 
		int tmp;
		for(int i = 0; i < numFunc; i++){
			tmp = multiHash.hash(i, str);
			counter[tmp]--;
			if (counter[tmp]==0) bitSet.set(tmp, false);
			//System.out.println("Set bit: " + tmp);
		}	
		//System.out.println("remove2 :"+str);
	}

}//end class BloomFilter3
